import "Turbine" 
import "Turbine.UI" 
import "Turbine.UI.Lotro" 
import "Turbine.Gameplay"

import "Thardariel.SkillData";

_G.player = Turbine.Gameplay.LocalPlayer.GetInstance()

function ChatOutput(string) Turbine.Shell.WriteLine(string) end

-- safely add a callback without overwriting any existing ones
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

function SaveSettings()

    Turbine.PluginData.Save(Turbine.DataScope.Character, "VitalSelf", _G.settings)

end

function Help_Legendary()
		
		mainWindow_helpLegendary = Turbine.UI.Lotro.GoldWindow()
		mainWindow_helpLegendary:SetSize(500,180)
		mainWindow_helpLegendary:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow_helpLegendary:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow_helpLegendary:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_helpLegendary:SetText("");
		elseif l == Turbine.Language.German then
			mainWindow_helpLegendary:SetText("Legendäre Gegenstände");
		elseif l == Turbine.Language.French then
			mainWindow_helpLegendary:SetText("");
		end
		
		mainWindow_helpLegendary.Message = Turbine.UI.Label()
		mainWindow_helpLegendary.Message:SetParent(mainWindow_helpLegendary)
		mainWindow_helpLegendary.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		mainWindow_helpLegendary.Message:SetText("Du hast nun Level 45 erreicht und bist somit bereit für die legendären Waffen!\nIm folgenden erhälst du einen Einblick über alle nötigen Informationen die du zum legendären Waffensystem benötigst.")
		mainWindow_helpLegendary.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
		mainWindow_helpLegendary.Message:SetSize(475,150)
		mainWindow_helpLegendary.Message:SetPosition(12, 40)
		
		legButton1 = Turbine.UI.Lotro.GoldButton()
		legButton1:SetParent(mainWindow_helpLegendary)
		legButton1:SetSize(190,20);
		legButton1:SetPosition((mainWindow_helpLegendary.Message:GetWidth()/3), 130)
		legButton1:SetText("Weiter")
		
		uralteSchriften = Turbine.UI.Lotro.GoldWindow()
		uralteSchriften:SetSize(500,240)
		uralteSchriften:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow_helpLegendary:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow_helpLegendary:GetHeight())/4)
		uralteSchriften:SetText("Uralte Schriften")
		
		uralteSchriften.Message = Turbine.UI.Label()
		uralteSchriften.Message:SetParent(uralteSchriften)
		uralteSchriften.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		uralteSchriften.Message:SetText("Dies ist die Hauptwährung für Eure neuen LGs, ähnlich wie bisher Aschepartikel und Asche der Verzauberung. Ihr erhaltet sie durch Entzauberungen gewisser Gegenstände (Filigranmuster, Attributsersatzschriftrollen, Kristalle etc.) und durch die Zerlegung alter LGs, die dadurch nicht verloren gehen und weiterhin genutzt werden können!\n\nDie Anzahl deiner uralten Schriften kannst du in deinem Geldbeutel einsehen.")
		uralteSchriften.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
		uralteSchriften.Message:SetSize(475,200)
		uralteSchriften.Message:SetPosition(12, 40)
		
		legButtonForward = Turbine.UI.Lotro.GoldButton()
		legButtonForward:SetParent(uralteSchriften)
		legButtonForward:SetSize(190,20);
		legButtonForward:SetPosition((uralteSchriften.Message:GetWidth()/1.8), 200)
		legButtonForward:SetText("Weiter")
		
		legButtonBack = Turbine.UI.Lotro.GoldButton()
		legButtonBack:SetParent(uralteSchriften)
		legButtonBack:SetSize(190,20);
		legButtonBack:SetPosition((uralteSchriften.Message:GetWidth()/8), 200)
		legButtonBack:SetText("Zurück")
		
		zer_filigranmuster = Turbine.UI.Lotro.GoldWindow()
		zer_filigranmuster:SetSize(500,300)
		zer_filigranmuster:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow_helpLegendary:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow_helpLegendary:GetHeight())/4)
		zer_filigranmuster:SetText("Zerschmetterte Filigranmuster")
		
		zer_filigranmuster.Message = Turbine.UI.Label()
		zer_filigranmuster.Message:SetParent(zer_filigranmuster)
		zer_filigranmuster.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		zer_filigranmuster.Message:SetText("Um Filigranmuster in Türkisblau- oder Goldqualität zu erhalten, benötigt Ihr diese zusätzlich zu Uralten Schriften. Diese sind begrenzt durch die Erweiterung oder die Stufe, aus der ihr den Inhalt ausführt. Beute aus dem Abscheulichen Schlund gibt Euch beispielsweise Khazad-Fragmente. Auf Stufe 130 erhaltet Ihr Fragmente aus Minas Morgul und so weiter. Die Fragmente sind an den Spielinhalt bzw. dessen Stufe angepasst. Ihr müsst also höherstufige Instanzen und Raids laufen, oder das Epos spielen, um an die besseren Fragmente heranzukommen.\n\nDie zerschmetterten Filigranmuster sind im Inventar zu finden.")
		zer_filigranmuster.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
		zer_filigranmuster.Message:SetSize(475,260)
		zer_filigranmuster.Message:SetPosition(12, 40)
		
		legButtonForward1 = Turbine.UI.Lotro.GoldButton()
		legButtonForward1:SetParent(zer_filigranmuster)
		legButtonForward1:SetSize(190,20);
		legButtonForward1:SetPosition((zer_filigranmuster.Message:GetWidth()/1.8), 260)
		legButtonForward1:SetText("Weiter")
		
		legButtonBack1 = Turbine.UI.Lotro.GoldButton()
		legButtonBack1:SetParent(zer_filigranmuster)
		legButtonBack1:SetSize(190,20);
		legButtonBack1:SetPosition((zer_filigranmuster.Message:GetWidth()/8), 260)
		legButtonBack1:SetText("Zurück")
		
		leg_items = Turbine.UI.Lotro.GoldWindow()
		leg_items:SetSize(500,300)
		leg_items:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow_helpLegendary:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow_helpLegendary:GetHeight())/4)
		leg_items:SetText("Das Archiv der Filigranmuster")
		
		leg_items.Message = Turbine.UI.Label()
		leg_items.Message:SetParent(leg_items)
		leg_items.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		leg_items.Message:SetText("Ihr könnt Eure neuen LGs von der Tauschhändlerin im ‘Letzten heimeligen Haus’ in Bruchtal erhalten. Sobald Ihr im Haus angekommen seid, begebt Euch linkerhand in das obere Stockwerk und betretet ‘Gobeth Teithian – Das Archiv der Filigranmuster‘. Hier findet Ihr alles, was Ihr benötigt.\n\nUm Eure neuen LGs ausrüsten zu können, müsst Ihr die alten (beide!) aus den Steckplätzen in Eure Taschen ziehen, sonst funktioniert es derzeit noch nicht.\n\nDie neuen LGs sind sockelbare Gegenstände. Die Menge der Sockel ist abhängig von Eurer Stufe und bestehen aus:")
		leg_items.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
		leg_items.Message:SetSize(475,260)
		leg_items.Message:SetPosition(12, 40)
		
		legButtonForward2 = Turbine.UI.Lotro.GoldButton()
		legButtonForward2:SetParent(leg_items)
		legButtonForward2:SetSize(190,20);
		legButtonForward2:SetPosition((leg_items.Message:GetWidth()/1.8), 260)
		legButtonForward2:SetText("Weiter")
		
		legButtonBack2 = Turbine.UI.Lotro.GoldButton()
		legButtonBack2:SetParent(leg_items)
		legButtonBack2:SetSize(190,20);
		legButtonBack2:SetPosition((leg_items.Message:GetWidth()/8), 260)
		legButtonBack2:SetText("Zurück")
		
		filigranmuster = Turbine.UI.Lotro.GoldWindow()
		filigranmuster:SetSize(500,300)
		filigranmuster:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow_helpLegendary:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow_helpLegendary:GetHeight())/4)
		filigranmuster:SetText("Sockel / Filigranmuster")
		
		filigranmuster.Message = Turbine.UI.Label()
		filigranmuster.Message:SetParent(filigranmuster)
		filigranmuster.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		filigranmuster.Message:SetText(string.format("Diese Gegenstände dienen jetzt der Anpassung des LIs und kommen in 4 Varianten:\n\n- Heraldische Filigranmuster\n- Worte des Handwerks\n- Worte der Macht\n- Worte der Beherrschung"))
		filigranmuster.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
		filigranmuster.Message:SetSize(475,260)
		filigranmuster.Message:SetPosition(12, 40)
		
		legButtonForward3 = Turbine.UI.Lotro.GoldButton()
		legButtonForward3:SetParent(filigranmuster)
		legButtonForward3:SetSize(190,20);
		legButtonForward3:SetPosition((filigranmuster.Message:GetWidth()/1.8), 260)
		legButtonForward3:SetText("Weiter")
		
		legButtonBack3 = Turbine.UI.Lotro.GoldButton()
		legButtonBack3:SetParent(filigranmuster)
		legButtonBack3:SetSize(190,20);
		legButtonBack3:SetPosition((filigranmuster.Message:GetWidth()/8), 260)
		legButtonBack3:SetText("Zurück")
		
		herald = Turbine.UI.Lotro.GoldWindow()
		herald:SetSize(500,300)
		herald:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow_helpLegendary:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow_helpLegendary:GetHeight())/4)
		herald:SetText("Heraldische Filigranmuster")
		
		herald.Message = Turbine.UI.Label()
		herald.Message:SetParent(herald)
		herald.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		herald.Message:SetText(string.format("Je Gegenstand ein Muster, durch das jeweilige Basis-Attribut (Macht, Beweglichkeit, Wille) ist die Auswahl bereits zum Teil getroffen, jetzt kann noch in kleinen Teilen angepasst werden"))
		herald.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
		herald.Message:SetSize(475,260)
		herald.Message:SetPosition(12, 40)
		
		legButtonForward4 = Turbine.UI.Lotro.GoldButton()
		legButtonForward4:SetParent(herald)
		legButtonForward4:SetSize(190,20);
		legButtonForward4:SetPosition((herald.Message:GetWidth()/1.8), 260)
		legButtonForward4:SetText("Weiter")
		
		legButtonBack4 = Turbine.UI.Lotro.GoldButton()
		legButtonBack4:SetParent(herald)
		legButtonBack4:SetSize(190,20);
		legButtonBack4:SetPosition((herald.Message:GetWidth()/8), 260)
		legButtonBack4:SetText("Zurück")
		
		function legButton1:MouseClick(sender, args)
			mainWindow_helpLegendary:SetVisible(false)
			uralteSchriften:SetVisible(true)
		end	
		
		function legButtonForward:MouseClick(sender, args)
			uralteSchriften:SetVisible(false)
			zer_filigranmuster:SetVisible(true)
		end
		
		function legButtonBack:MouseClick(sender, args)
			uralteSchriften:SetVisible(false)
			mainWindow_helpLegendary:SetVisible(true)
		end
	
		function legButtonForward1:MouseClick(sender, args)
			zer_filigranmuster:SetVisible(false)
			leg_items:SetVisible(true)
		end
		
		function legButtonBack1:MouseClick(sender, args)
			zer_filigranmuster:SetVisible(false)
			uralteSchriften:SetVisible(true)
		end
		
		function legButtonForward2:MouseClick(sender, args)
			leg_items:SetVisible(false)
			filigranmuster:SetVisible(true)
		end
		
		function legButtonBack2:MouseClick(sender, args)
			zer_filigranmuster:SetVisible(true)
			leg_items:SetVisible(false)
		end
		
		function legButtonForward3:MouseClick(sender, args)
			filigranmuster:SetVisible(false)
			herald:SetVisible(true)
		end
		
		function legButtonBack3:MouseClick(sender, args)
			filigranmuster:SetVisible(true)
			herald:SetVisible(false)
		end
		
		mainWindow_helpLegendary:SetVisible(true)
		
end

function MainFunction_Moria()
		
		
		local file_path_moria = "Thardariel/WelcomeToMiddleEarth/images/MinesOfMoria.jpg";
			
		mainWindow_Moria = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Moria:SetSize(600,396);
		mainWindow_Moria:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Moria:SetText("The mines of Moria!");
		elseif l == Turbine.Language.German then
			mainWindow_Moria:SetText("Die Minen von Moria!");
		elseif l == Turbine.Language.French then
			mainWindow_Moria:SetText("Les mines de la Moria!");
		end
		mainWindow_Moria.Image=Turbine.UI.Label(); 
		mainWindow_Moria.Image:SetParent(mainWindow_Moria);
		mainWindow_Moria.Image:SetSize(550,229);
		mainWindow_Moria.Image:SetPosition(25, 140)
		mainWindow_Moria.Image:SetBackground(file_path_moria);
		mainWindow_Moria.Message=Turbine.UI.Label(); 
		mainWindow_Moria.Message:SetParent(mainWindow_Moria);
		mainWindow_Moria.Message:SetSize(550,229);
		mainWindow_Moria.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
		mainWindow_Moria.Message:SetPosition(25, 50)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Moria.Message:SetText("Moria. You are afraid of these mines. The dwarves have mined too greedily and too deeply. You know what they have awakened in the darkness of Kazad-dûm: shadows and flames. ~ Saruman\n\nMeet Ráthwald in Echad Dúnann (Eregion) to take the path into the mines of Moria!")
		elseif l == Turbine.Language.German then
			mainWindow_Moria.Message:SetText("Moria. Du fürchtest dich vor diesen Minen. Die Zwerge haben zu gierig und zu tief geschürft. Du weißt, was sie aufgeweckt haben in der Dunkelheit von Kazad-dûm: Schatten und Flammen. ~ Saruman\n\nTreffe Ráthwald in Echad Dúnann (Eregion) um den Pfad in die Minen von Moria zu bestreiten!")
		elseif l == Turbine.Language.French then
			mainWindow_Moria.Message:SetText("La Moria. Tu as peur de ces mines. Les nains ont creusé trop avidement et trop profondément. Tu sais ce qu'ils ont réveillé dans les ténèbres de Kazad-dûm : des ombres et des flammes. ~ Saruman\n\nRencontre Ráthwald à Echad Dúnann (Eregion) pour prendre le chemin des mines de la Moria !")
		end
		mainWindow_Moria.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Moria:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Moria:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_Bree()
		
		
		local file_path_bree = "Thardariel/WelcomeToMiddleEarth/images/Bree.jpg";
			
		mainWindow_Bree = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Bree:SetSize(600,396);
		mainWindow_Bree:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Bree:SetText("The prancing pony!")
		elseif l == Turbine.Language.German then
			mainWindow_Bree:SetText("Gasthaus zum tänzelnden Pony!")
		elseif l == Turbine.Language.French then
			mainWindow_Bree:SetText("Auberge du poney dansant!")
		end
		mainWindow_Bree.Image=Turbine.UI.Label(); 
		mainWindow_Bree.Image:SetParent(mainWindow_Bree);
		mainWindow_Bree.Image:SetSize(550,218);
		mainWindow_Bree.Image:SetPosition(25, 140)
		mainWindow_Bree.Image:SetBackground(file_path_bree);
		mainWindow_Bree.Message=Turbine.UI.Label(); 
		mainWindow_Bree.Message:SetParent(mainWindow_Bree);
		mainWindow_Bree.Message:SetSize(550,229);
		mainWindow_Bree.Message:SetPosition(25, 50)
		mainWindow_Bree.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Bree.Message:SetText("You are drawing far too much attention to yourself, Mr. Unterberg! ~ Your path takes you to the Breeland. Meet Barliman Butterbur at the Prancing Pony Inn.")
		elseif l == Turbine.Language.German then
			mainWindow_Bree.Message:SetText("Ihr zieht bei weitem zu viel Aufmerksamkeit auf Euch, Herr Unterberg! ~ Streicher\n\nEuer Weg verschlägt euch ins Breeland. Trefft Gerstenmann Butterblume im Gasthaus zum tänzelnden Pony.")
		elseif l == Turbine.Language.French then
			mainWindow_Bree.Message:SetText("Vous attirez beaucoup trop l'attention sur vous, Monsieur Unterberg ! ~ Streichern\nVotre chemin vous mènera dans le Breeland. Rencontrez Bouton d'orge à l'auberge du Poney dansant.")
		end
		mainWindow_Bree.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Bree:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Bree:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_EinsameLande()
		
		
		local file_path_einsamelande = "Thardariel/WelcomeToMiddleEarth/images/Wetterspitze.jpg";
			
		mainWindow_EinsameLande = Turbine.UI.Lotro.GoldWindow()
		mainWindow_EinsameLande:SetSize(600,396);
		mainWindow_EinsameLande:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_EinsameLande:SetText("The weather top!")
		elseif l == Turbine.Language.German then
			mainWindow_EinsameLande:SetText("Die Wetterspitze!")
		elseif l == Turbine.Language.French then
			mainWindow_EinsameLande:SetText("La pointe météo!")
		end
		mainWindow_EinsameLande.Image=Turbine.UI.Label(); 
		mainWindow_EinsameLande.Image:SetParent(mainWindow_EinsameLande);
		mainWindow_EinsameLande.Image:SetSize(550,218);
		mainWindow_EinsameLande.Image:SetPosition(25, 140)
		mainWindow_EinsameLande.Image:SetBackground(file_path_einsamelande);
		mainWindow_EinsameLande.Message=Turbine.UI.Label(); 
		mainWindow_EinsameLande.Message:SetParent(mainWindow_EinsameLande);
		mainWindow_EinsameLande.Message:SetSize(550,229);
		mainWindow_EinsameLande.Message:SetPosition(25, 50)
		mainWindow_EinsameLande.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_EinsameLande.Message:SetText("The Witch-King has wounded Frodo on Weathertop with a Morgul Blade, but Strider was able to drive the Nazgûl away. All is not well with him, he must join Lord Elrond in Rivendell. Quickly!\n\nSpeak with Candaith on the slope of the weathertop.")
		elseif l == Turbine.Language.German then
			mainWindow_EinsameLande.Message:SetText("Der Hexenkönig hat Frodo auf der Wetterspitze mit einer Morgulklinge verwundet, doch Streicher konnte die Nazgûl vertreiben. Es steht nicht gut um ihn, er muss zu Herrn Elrond nach Bruchtall. Schnell!\n\nSprecht mit Candaith am Hang der Wetterspitze.")
		elseif l == Turbine.Language.French then
			mainWindow_EinsameLande.Message:SetText("Le Roi-Sorcier a blessé Frodon avec une lame de Morgul sur le Pic du Temps, mais Streicher a réussi à repousser les Nazgûl. Les choses ne vont pas bien pour lui, il doit rejoindre le Seigneur Elrond à Fondcombe. Vite!\NParle avec Candaith sur le versant de la Pointe du Temps.")
		end	
		mainWindow_EinsameLande.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_EinsameLande:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_EinsameLande:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_Bruchtal()
		
		
		local file_path_bruchtal = "Thardariel/WelcomeToMiddleEarth/images/Bruchtal.jpg";
			
		mainWindow_Bruchtal = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Bruchtal:SetSize(600,431);
		mainWindow_Bruchtal:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Bruchtal:SetText("Rivendell!")
		elseif l == Turbine.Language.German then
			mainWindow_Bruchtal:SetText("Bruchtal!")
		elseif l == Turbine.Language.French then
			mainWindow_Bruchtal:SetText("Rivetal!")
		end
		mainWindow_Bruchtal.Image=Turbine.UI.Label(); 
		mainWindow_Bruchtal.Image:SetParent(mainWindow_Bruchtal);
		mainWindow_Bruchtal.Image:SetSize(550,218);
		mainWindow_Bruchtal.Image:SetPosition(25, 175)
		mainWindow_Bruchtal.Image:SetBackground(file_path_bruchtal);
		mainWindow_Bruchtal.Message=Turbine.UI.Label(); 
		mainWindow_Bruchtal.Message:SetParent(mainWindow_Bruchtal);
		mainWindow_Bruchtal.Message:SetSize(550,229);
		mainWindow_Bruchtal.Message:SetPosition(25, 50)
		mainWindow_Bruchtal.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Bruchtal.Message:SetText("The ring cannot be destroyed, Gimli, Gloin's son. At least, not by any power we possess here. Created in the fires of Mount Doom, it can only be destroyed there! He must be taken deep into Mordor and cast back into the fiery embers from whence he came. One of you must do this! \So be it! Nine Companions. So you form the Fellowship of the Ring! ~ Elrond")
		elseif l == Turbine.Language.German then
			mainWindow_Bruchtal.Message:SetText("Der Ring kann nicht zerstört werden, Gimli, Gloins Sohn. Jedenfalls von keiner Kraft, die wir hier besitzen. In den Feuern des Schicksalsberges erschaffen, kann er nur dort zerstört werden! Man muss ihn tief nach Mordor hineinbringen und ihn in die feurige Glut zurückwerfen, aus der er stammt. Einer von euch muss das tun! \n\nSo sei es! Neun Gefährten. Ihr bildet also die Gemeinschaft des Ringes! ~ Elrond")
		elseif l == Turbine.Language.French then
			mainWindow_Bruchtal.Message:SetText("L'Anneau ne peut pas être détruit, Gimli, fils de Gloin. En tout cas, par aucun des pouvoirs que nous possédons ici. Créé dans les flammes de la Montagne du Destin, il ne peut être détruit que là! Il faut l'emmener au plus profond du Mordor et le rejeter dans les braises ardentes d'où il est issu. L'un d'entre vous doit le faire! \n\nSo soit! Neuf compagnons. Vous formez donc la communauté de l'Anneau! ~ Elrond")
		end
		mainWindow_Bruchtal.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Bruchtal:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Bruchtal:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_Lothlorien()
		
		
		local file_path_lothlorien = "Thardariel/WelcomeToMiddleEarth/images/Lothlorien.jpg";
			
		mainWindow_Lothlorien = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Lothlorien:SetSize(600,436);
		mainWindow_Lothlorien:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Lothlorien:SetText("Lothlorien!");
		elseif l == Turbine.Language.German then
			mainWindow_Lothlorien:SetText("Lothlorien!");
		elseif l == Turbine.Language.French then
			mainWindow_Lothlorien:SetText("Lothlorien!");
		end
		mainWindow_Lothlorien.Image=Turbine.UI.Label(); 
		mainWindow_Lothlorien.Image:SetParent(mainWindow_Lothlorien);
		mainWindow_Lothlorien.Image:SetSize(550,218);
		mainWindow_Lothlorien.Image:SetPosition(25, 180)
		mainWindow_Lothlorien.Image:SetBackground(file_path_lothlorien);
		mainWindow_Lothlorien.Message=Turbine.UI.Label(); 
		mainWindow_Lothlorien.Message:SetParent(mainWindow_Lothlorien);
		mainWindow_Lothlorien.Message:SetSize(550,229);
		mainWindow_Lothlorien.Message:SetPosition(25, 50)
		mainWindow_Lothlorien.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		mainWindow_Lothlorien.Message:SetText("Der Feind weiß, dass ihr hier eingetroffen seid. Eure Hoffnung unerkannt zu bleiben, sie ist nun zunichte.Hier sind acht, doch neun sind von Bruchtal aus aufgebrochen. Sagt mir, wo ist Gandalf, denn es verlangt mich sehr mit ihm zu sprechen. Ich kann ihn aus weiter Ferne nicht sehen. ~ Celeborn\n\nGandalf der Graue hat die Grenzen dieses Landes nicht überschritten. Er ist in den Schatten gestürzt. ~ Galadriel")
		mainWindow_Lothlorien.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Lothlorien:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Lothlorien:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_Isengart()
		
		
		local file_path_isengart = "Thardariel/WelcomeToMiddleEarth/images/Isengart.jpg";
			
		mainWindow_Isengart = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Isengart:SetSize(600,406);
		mainWindow_Isengart:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Isengart:SetText("Isengart!");
		elseif l == Turbine.Language.German then
			mainWindow_Isengart:SetText("Isengart!");
		elseif l == Turbine.Language.French then
			mainWindow_Isengart:SetText("Isengart!");
		end
		mainWindow_Isengart.Image=Turbine.UI.Label(); 
		mainWindow_Isengart.Image:SetParent(mainWindow_Isengart);
		mainWindow_Isengart.Image:SetSize(550,218);
		mainWindow_Isengart.Image:SetPosition(25, 150)
		mainWindow_Isengart.Image:SetBackground(file_path_isengart);
		mainWindow_Isengart.Message=Turbine.UI.Label(); 
		mainWindow_Isengart.Message:SetParent(mainWindow_Isengart);
		mainWindow_Isengart.Message:SetSize(550,229);
		mainWindow_Isengart.Message:SetPosition(25, 50)
		mainWindow_Isengart.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Isengart.Message:SetText("If the wall is breached, Helm's Deep will fall. ~ Even if it were breached, an unimaginable number would be needed. Thousands to storm the fortress! ~ Gríma\nTen thousand. ~ Saruman\nBut my lord, there is no such force. ~ Gríma\nA new power is rising and its victory is near. ~Saruman")
		elseif l == Turbine.Language.German then
			mainWindow_Isengart.Message:SetText("Wird der Wall durchbrochen, fällt Helms Klamm. ~ Saruman\nSelbst wenn man ihn durchbräche, eine unvorstellbare Anzahl wäre von Nöten. Tausende um die Festung zu stürmen! ~ Gríma\nZehntausende. ~ Saruman\nAber mein Gebieter, eine solche Streitmacht gibt es nicht. ~ Gríma\nEine neue Macht erhebt sich und ihr Sieg ist nah. ~Saruman")
		elseif l == Turbine.Language.French then
			mainWindow_Isengart.Message:SetText("Si le mur est franchi, le Gouffre de Helm tombe. ~ Saruman\nMême si on le franchissait, il faudrait un nombre inimaginable de personnes. Des milliers pour prendre la forteresse d'assaut! ~ Gríma\nDix mille personnes. ~ Saruman\nMais mon maître, une telle force n'existe pas. ~ Gríma\nUne nouvelle force se lève et sa victoire est proche. ~Saruman")
		end
		mainWindow_Isengart.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Isengart:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Isengart:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_AmonHen()
		
		
		local file_path_amonhen = "Thardariel/WelcomeToMiddleEarth/images/AmonHen.jpg";
			
		mainWindow_AmonHen = Turbine.UI.Lotro.GoldWindow()
		mainWindow_AmonHen:SetSize(600,421);
		mainWindow_AmonHen:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_AmonHen:SetText("Amon Hen!");
		elseif l == Turbine.Language.German then
			mainWindow_AmonHen:SetText("Amon Hen!");
		elseif l == Turbine.Language.French then
			mainWindow_AmonHen:SetText("Amon Hen!");
		end
		mainWindow_AmonHen.Image=Turbine.UI.Label(); 
		mainWindow_AmonHen.Image:SetParent(mainWindow_AmonHen);
		mainWindow_AmonHen.Image:SetSize(550,218);
		mainWindow_AmonHen.Image:SetPosition(25, 165)
		mainWindow_AmonHen.Image:SetBackground(file_path_amonhen);
		mainWindow_AmonHen.Message=Turbine.UI.Label(); 
		mainWindow_AmonHen.Message:SetParent(mainWindow_AmonHen);
		mainWindow_AmonHen.Message:SetSize(550,229);
		mainWindow_AmonHen.Message:SetPosition(25, 50)
		mainWindow_AmonHen.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_AmonHen.Message:SetText("I would have followed you my brother, my captain, my king! ~ Boromir\n\nPeace be with you, son of Gondor. ~ Aragorn\n\nAt this point the Fellowship of the Ring separates. Aragorn, Legolas and Gimli follow the trail of the Uruk-Hai to rescue Merry and Pippin. Frodo and Sam are now on their own, for now.")
		elseif l == Turbine.Language.German then
			mainWindow_AmonHen.Message:SetText("Ich wäre dir gefolgt mein Bruder, mein Hauptmann, mein König! ~ Boromir\n\nFriede sei mit dir, Sohn Gondors. ~ Aragorn\n\nAn diesem Punkt trennt sich die Gemeinschaft des Ringes. Aragorn, Legolas und Gimli verfolgen die Spur der Uruk-Hai, um Merry und Pippin zu retten. Frodo und Sam sind nun auf sich allein gestellt, vorerst.")
		elseif l == Turbine.Language.French then
			mainWindow_AmonHen.Message:SetText("Je t'aurais suivi mon frère, mon capitaine, mon roi ! ~ Boromir\n\nLa paix soit avec toi, fils du Gondor. ~ Aragorn\n\nA ce stade, la communauté de l'Anneau se sépare. Aragorn, Legolas et Gimli suivent la piste des Uruk-Hai pour sauver Merry et Pippin. Frodon et Sam sont désormais livrés à eux-mêmes, pour le moment.")
		end
		mainWindow_AmonHen.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_AmonHen:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_AmonHen:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_Edoras()
		
		
		local file_path_edoras = "Thardariel/WelcomeToMiddleEarth/images/Edoras.jpg";
			
		mainWindow_Edoras = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Edoras:SetSize(600,396);
		mainWindow_Edoras:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Edoras:SetText("Edoras!");
		elseif l == Turbine.Language.German then
			mainWindow_Edoras:SetText("Edoras!");
		elseif l == Turbine.Language.French then
			mainWindow_Edoras:SetText("Edoras!");
		end
		mainWindow_Edoras.Image=Turbine.UI.Label(); 
		mainWindow_Edoras.Image:SetParent(mainWindow_Edoras);
		mainWindow_Edoras.Image:SetSize(550,218);
		mainWindow_Edoras.Image:SetPosition(25, 140)
		mainWindow_Edoras.Image:SetBackground(file_path_edoras);
		mainWindow_Edoras.Message=Turbine.UI.Label(); 
		mainWindow_Edoras.Message:SetParent(mainWindow_Edoras);
		mainWindow_Edoras.Message:SetSize(550,229);
		mainWindow_Edoras.Message:SetPosition(25, 50)
		mainWindow_Edoras.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Edoras.Message:SetText("I am Gandalf the White, and I return to you. At the turning point of the tides. One stage of your journey is over. Now comes the next. War has come upon Rohan. We must ride to Edoras as swiftly as we can. ~ Gandalf")
		elseif l == Turbine.Language.German then
			mainWindow_Edoras.Message:SetText("Ich bin Gandalf der Weiße und ich kehre zurück zu euch. Am Wendepunkt der Gezeiten. Eine Etappe eurer Reise ist vorüber. Nun folgt die nächste. Krieg ist über Rohan bgekommen. Wir müssen nach Edoras reiten, so geschwind wir können. ~ Gandalf")
		elseif l == Turbine.Language.French then
			mainWindow_Edoras.Message:SetText("Je suis Gandalf le Blanc et je reviens vers vous. Au point d'inflexion des marées. Une étape de votre voyage est terminée. Voici la prochaine. La guerre est arrivée au Rohan. Nous devons nous rendre à Edoras aussi vite que possible. ~ Gandalf")
		end
		mainWindow_Edoras.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Edoras:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Edoras:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_HelmsKlamm()
		
		
		local file_path_helmsklamm = "Thardariel/WelcomeToMiddleEarth/images/HelmsKlamm.jpg";
			
		mainWindow_HelmsKlamm = Turbine.UI.Lotro.GoldWindow()
		mainWindow_HelmsKlamm:SetSize(600,436);
		mainWindow_HelmsKlamm:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_HelmsKlamm:SetText("Helm's Deep!");
		elseif l == Turbine.Language.German then
			mainWindow_HelmsKlamm:SetText("Helms Klamm!");
		elseif l == Turbine.Language.French then
			mainWindow_HelmsKlamm:SetText("Le gouffre de Helm!");
		end
		mainWindow_HelmsKlamm.Image=Turbine.UI.Label(); 
		mainWindow_HelmsKlamm.Image:SetParent(mainWindow_HelmsKlamm);
		mainWindow_HelmsKlamm.Image:SetSize(550,218);
		mainWindow_HelmsKlamm.Image:SetPosition(25, 180)
		mainWindow_HelmsKlamm.Image:SetBackground(file_path_helmsklamm);
		mainWindow_HelmsKlamm.Message=Turbine.UI.Label(); 
		mainWindow_HelmsKlamm.Message:SetParent(mainWindow_HelmsKlamm);
		mainWindow_HelmsKlamm.Message:SetSize(550,229);
		mainWindow_HelmsKlamm.Message:SetPosition(25, 50)
		mainWindow_HelmsKlamm.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_HelmsKlamm.Message:SetText("Await my coming, at the first light of the fifth day. At sunrise, look to the east. ~ Gandalf\n\nAn enemy had never entered the gorge before the Uruk-hai attack. It is also said that when men defended this fortification, the enemy had never been able to take a step inside the inner ring of the Hornburg. But Saruman's army was strong enough to take this fortress.")
		elseif l == Turbine.Language.German then
			mainWindow_HelmsKlamm.Message:SetText("Erwartet mein Kommen, beim ersten Licht des fünften Tages. Bei Sonnenaufgang, schaut nach Osten. ~ Gandalf\n\nIn die Klamm war vor dem Angriff der Uruk-hai noch nie ein Feind eingedrungen. Es heißt ausserdem, dass, wenn Menschen diese Befestigung verteidigten, der Feind noch nie einen Schritt in den Innenring der Hornburg setzen konnte. Doch Sarumans Heer war stark genug diese Festung einzunehmen.")
		elseif l == Turbine.Language.French then
			mainWindow_HelmsKlamm.Message:SetText("Attendez-vous à ma venue, aux premières lueurs du cinquième jour. Au lever du soleil, regardez vers l'est. ~ Gandalf\n\NAucun ennemi n'avait jamais pénétré dans la gorge avant l'attaque des Uruk-hai. On dit en outre que si des hommes défendaient cette fortification, l'ennemi n'avait jamais pu faire un pas dans l'anneau intérieur du château de Horn. Mais l'armée de Saroumane était suffisamment puissante pour prendre cette forteresse.")
		end
		mainWindow_HelmsKlamm.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_HelmsKlamm:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_HelmsKlamm:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_MinasTirith()
		
		
		local file_path_minastirith = "Thardariel/WelcomeToMiddleEarth/images/MinasTirith.jpg";
			
		mainWindow_MinasTirith = Turbine.UI.Lotro.GoldWindow()
		mainWindow_MinasTirith:SetSize(600,416);
		mainWindow_MinasTirith:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_MinasTirith:SetText("Minas Tirith!");
		elseif l == Turbine.Language.German then
			mainWindow_MinasTirith:SetText("Minas Tirith!");
		elseif l == Turbine.Language.French then
			mainWindow_MinasTirith:SetText("Minas Tirith!");
		end
		mainWindow_MinasTirith.Image=Turbine.UI.Label(); 
		mainWindow_MinasTirith.Image:SetParent(mainWindow_MinasTirith);
		mainWindow_MinasTirith.Image:SetSize(550,218);
		mainWindow_MinasTirith.Image:SetPosition(25, 160)
		mainWindow_MinasTirith.Image:SetBackground(file_path_minastirith);
		mainWindow_MinasTirith.Message=Turbine.UI.Label(); 
		mainWindow_MinasTirith.Message:SetParent(mainWindow_MinasTirith);
		mainWindow_MinasTirith.Message:SetSize(550,229);
		mainWindow_MinasTirith.Message:SetPosition(25, 50)
		mainWindow_MinasTirith.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_MinasTirith.Message:SetText("The beacons of Minas Tirith, the beacons burn! Gondor calls for help!\nAnd Rohan will answer! Let the show of arms begin! \nSpear shall shatter, shield shall shatter, a sword-day, a blood-day, before the sun rises. Ride, ride now, Ride to destruction and the end of the world. DEATH! ~ Theoden")
		elseif l == Turbine.Language.German then
			mainWindow_MinasTirith.Message:SetText("Die Leuchtfeuer von Minas Tirith, die Leuchtfeuer brennen! Gondor ruft um Hilfe!\nUnd Rohan wird antworten! Die Heerschau soll beginnen! \n\nSpeer wird zerschellen, Schild zersplittern, ein Schwerttag, ein Bluttag, ehe die Sonne steigt. Reitet, Reitet nun, Reitet zur Vernichtung und zum Ende der Welt. TOD! ~ Theoden")
		elseif l == Turbine.Language.French then
			mainWindow_MinasTirith.Message:SetText("Les feux de Minas Tirith, les feux sont allumés ! Le Gondor appelle à l'aide!\nUn Rohan répondra ! Que le spectacle de l'armée commence ! \n\nLa lance se brisera, le bouclier volera en éclats, un jour d'épée, un jour de sang, avant que le soleil ne se lève. Chevauchez, chevauchez maintenant, chevauchez vers la destruction et la fin du monde. MORT ! ~ Théoden")
		end
		mainWindow_MinasTirith.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_MinasTirith:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_MinasTirith:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_Mordor()
		
		
		local file_path_mordor = "Thardariel/WelcomeToMiddleEarth/images/Mordor.jpg";
			
		mainWindow_Mordor = Turbine.UI.Lotro.GoldWindow()
		mainWindow_Mordor:SetSize(600,426);
		mainWindow_Mordor:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Mordor:SetText("Mordor!");
		elseif l == Turbine.Language.German then
			mainWindow_Mordor:SetText("Mordor!");
		elseif l == Turbine.Language.French then
			mainWindow_Mordor:SetText("Mordor!");
		end
		mainWindow_Mordor.Image=Turbine.UI.Label(); 
		mainWindow_Mordor.Image:SetParent(mainWindow_Mordor);
		mainWindow_Mordor.Image:SetSize(550,197);
		mainWindow_Mordor.Image:SetPosition(25, 205)
		mainWindow_Mordor.Image:SetBackground(file_path_mordor);
		mainWindow_Mordor.Message=Turbine.UI.Label(); 
		mainWindow_Mordor.Message:SetParent(mainWindow_Mordor);
		mainWindow_Mordor.Message:SetSize(550,229);
		mainWindow_Mordor.Message:SetPosition(25, 50)
		mainWindow_Mordor.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_Mordor.Message:SetText("Hold your ground! Hold your ground! Sons of Gondor and Rohan, my brothers! I see in your eyes the same fear that would make me despondent. The day may come when the courage of men is extinguished, when we forsake our companions, and all bonds of friendship are broken. But this day is still far away. The hour of the wolves and shattered shields, when the age of men thunders down, but this day is still far away! For today we fight! By all that you hold dear on this earth, I say: Stand fast, Men of the West!\n\nFor Frodo! ~ Aragorn")
		elseif l == Turbine.Language.German then
			mainWindow_Mordor.Message:SetText("Haltet eure Stellung! Haltet eure Stellung! Söhne Gondors und Rohans, meine Brüder! In euren Augen sehe ich dieselbe Furcht, die auch mich verzagen ließe. Der Tag mag kommen, da der Mut der Menschen erlischt, da wir unsere Gefährten im Stich lassen und aller Freundschaft Bande bricht. Doch dieser Tag ist noch fern. Die Stunde der Wölfe und zerschmetterter Schilde, da das Zeitalter der Menschen tosend untergeht, doch dieser Tag ist noch fern! Denn heute kämpfen wir! Bei allem, was euch teuer ist auf dieser Erde, sage ich: Haltet stand, Menschen des Westens!\n\nFür Frodo! ~ Aragorn")
		elseif l == Turbine.Language.French then
			mainWindow_Mordor.Message:SetText("Tenez votre position ! Tenez votre position ! Fils du Gondor et du Rohan, mes frères ! Je vois dans vos yeux la même peur qui m'a fait perdre espoir. Le jour viendra peut-être où le courage des hommes s'éteindra, où nous abandonnerons nos compagnons et où les liens de l'amitié seront rompus. Mais ce jour est encore loin. L'heure des loups et des boucliers brisés, où l'ère des hommes s'éteint avec fracas, mais ce jour est encore loin ! Car aujourd'hui, nous nous battons ! Par tout ce qui vous est cher sur cette terre, je vous le dis : tenez bon, peuple de l'Ouest!\NPour Frodo ! ~ Aragorn")
		end
		mainWindow_Mordor.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_Mordor:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_Mordor:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_GraueAnfurten()
		
		local file_path_graueanfurten = "Thardariel/WelcomeToMiddleEarth/images/GraueAnfurten.jpg";
			
		mainWindow_GraueAnfurten = Turbine.UI.Lotro.GoldWindow()
		mainWindow_GraueAnfurten:SetSize(600,416);
		mainWindow_GraueAnfurten:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth()),(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_GraueAnfurten:SetText("The gray havens!");
		elseif l == Turbine.Language.German then
			mainWindow_GraueAnfurten:SetText("Die grauen Anfurten!");
		elseif l == Turbine.Language.French then
			mainWindow_GraueAnfurten:SetText("Les anfractuosités grises!");
		end
		mainWindow_GraueAnfurten.Image=Turbine.UI.Label(); 
		mainWindow_GraueAnfurten.Image:SetParent(mainWindow_GraueAnfurten);
		mainWindow_GraueAnfurten.Image:SetSize(550,218);
		mainWindow_GraueAnfurten.Image:SetPosition(25, 160)
		mainWindow_GraueAnfurten.Image:SetBackground(file_path_graueanfurten);
		mainWindow_GraueAnfurten.Message=Turbine.UI.Label(); 
		mainWindow_GraueAnfurten.Message:SetParent(mainWindow_GraueAnfurten);
		mainWindow_GraueAnfurten.Message:SetSize(550,229);
		mainWindow_GraueAnfurten.Message:SetPosition(25, 50)
		mainWindow_GraueAnfurten.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		
		local l = Turbine.Engine.GetLanguage()
		if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
			mainWindow_GraueAnfurten.Message:SetText("And so it happened that the Fourth Age dawned on Middle Earth. And the Fellowship of the Ring, though eternally united in love and friendship, disintegrated. Exactly 13 months ago, Gandalf had sent us on our long journey. Now we were confronted with a strange sight. We were home! \n\n ~ Frodo")
		elseif l == Turbine.Language.German then
			mainWindow_GraueAnfurten.Message:SetText("Und so geschah es, dass das Vierte Zeitalter in Mittelerde anbrach. Und die Gemeinschaft des Ringes, obgleich ewig verbunden in Liebe und Freundschaft, löste sich auf. Genau vor 13 Monaten hatte uns Gandalf auf unsere lange Reise geschickt. Nun bot sich uns ein vertauter Anblick. Wir waren zu Hause! \n\n ~ Frodo")
		elseif l == Turbine.Language.French then
			mainWindow_GraueAnfurten.Message:SetText("Et c'est ainsi que le Quatrième Âge arriva sur la Terre du Milieu. Et la communauté de l'Anneau, bien qu'éternellement unie par l'amour et l'amitié, s'est dissoute. Il y a treize mois exactement, Gandalf nous avait envoyés dans notre long voyage. Maintenant, nous avions une vue imprenable. Nous étions à la maison ! \n\n ~ Frodo")
		end
		mainWindow_GraueAnfurten.Message:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)

		mainWindow_GraueAnfurten:SetVisible(true)
		
		mainWindow:SetVisible(false)
		function mainWindow_GraueAnfurten:Closed(sender, args)
			mainWindow:SetVisible(true)
		end
	
end

function MainFunction_LevelUp()


		function _G.player:LevelChanged(sender, args)
					
						mainWindow=Turbine.UI.Lotro.GoldWindow() 
						mainWindow:SetSize(600,150);
						mainWindow:SetPosition((Turbine.UI.Display:GetWidth()-mainWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-mainWindow:GetHeight())/4)
						
						local l = Turbine.Engine.GetLanguage()
						if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
							mainWindow:SetText("You're leveled up!")
						elseif l == Turbine.Language.German then
							mainWindow:SetText("Du bist aufgestiegen!")
						elseif l == Turbine.Language.French then
							mainWindow:SetText("Vous avez gagné des niveaux!")
						end
						
						mainWindow:SetVisible(true)
								
						mainWindow.Message=Turbine.UI.Label();
						mainWindow.Message:SetParent(mainWindow)
						mainWindow.Message:SetSize(570,150)
						mainWindow.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
						mainWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
						
						local l = Turbine.Engine.GetLanguage()
						if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
							mainWindow.Message:SetText(string.format("Congratulations %s, you are now level %s!\n\nThe following awaits you in the next levels:",_G.player:GetName(), _G.player:GetLevel()))
						elseif l == Turbine.Language.German then
							mainWindow.Message:SetText(string.format("Herzlichen Glückwunsch %s, du bist nun Level %s!\n\nFolgendes erwartet dich in den nächsten Leveln:",_G.player:GetName(), _G.player:GetLevel()))
						elseif l == Turbine.Language.French then
							mainWindow.Message:SetText(string.format("Félicitations %s, tu es maintenant au niveau %s!\n\nVoilà ce qui t'attend dans les prochains niveaux:",_G.player:GetName(), _G.player:GetLevel()))
						end
												
						if (player:GetClass() == Turbine.Gameplay.Class.Hunter) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Hunter
							

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70003F4E" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70003F4E" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70003F4E"}
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x70003F4C" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70003F4C" }	
							elseif (nextLevel == 7) then
								index = 2
								sc = { "0x70003F4C" }
							elseif (nextLevel == 8) then
								index = 4
								sc = { "0x70003F4C", "0x70003F34", "0x70003F45" }
							elseif (nextLevel == 9) then
								index = 3
								sc = { "0x70003F34", "0x70003F45" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x70003F3D" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "0x70003F3D" }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x70003F3E" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x70003F3E" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x70003F3E" }
							elseif (nextLevel == 15) then
								index = 3
								sc = { "0x70003F4D", "0x70003F39" }
							elseif (nextLevel == 16) then
								index = 3
								sc = { "0x70003F4D", "0x70003F39" }
							elseif (nextLevel == 17) then
								index = 2
								sc = { "0x70003F39" }
							elseif (nextLevel == 18) then
								index = 2
								sc = { "0x70003F39" }
							elseif (nextLevel == 19) then
								index = 4
								sc = { "0x70021D0D", "0x7003200C", "0x70003F40" }
							elseif (nextLevel == 20) then
								index = 4
								sc = { "0x70021D0D", "0x7003200C", "0x70003F40" }
							elseif (nextLevel == 21) then
								index = 5
								sc = { "0x700010D3", "0x70003F3F", "0x70003F46", "0x7000A2C3" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 5
								sc = { "0x700010D3", "0x70003F3F", "0x70003F46", "0x7000A2C3" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x70003F41" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x70003F41" }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x7000A2C1" }	
							elseif (nextLevel == 26) then
								index = 4
								sc = { "0x7000A2C1", "0x700030DE", "0x70003F4F" }
							elseif (nextLevel == 27) then
								index = 3
								sc = { "0x700030DE", "0x70003F4F" }
							elseif (nextLevel == 28) then
								index = 3
								sc = { "0x700030DE", "0x70003F4F" }
							elseif (nextLevel == 29) then
								index = 2
								sc = { "0x70003F37" }
							elseif (nextLevel == 30) then
								index = 2
								sc = { "0x70003F37" }
							elseif (nextLevel == 31) then
								index = 3
								sc = { "0x70003F47", "0x70003F42" }
							elseif (nextLevel == 32) then
								index = 3
								sc = { "0x70003F47", "0x70003F42" }
							elseif (nextLevel == 33) then
								index = 2
								sc = { "0x70003F43" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 2
								sc = { "0x70003F43"  }
							elseif (nextLevel == 35) then
								index = 1
								sc = { }
							elseif (nextLevel == 36) then
								index = 2
								sc = { "0x700030EC" }
							elseif (nextLevel == 37) then
								index = 2
								sc = { "0x700030EC" }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x700030EC" }
							elseif (nextLevel == 39) then
								index = 2
								sc = { "0x70003F48" }
							elseif (nextLevel == 40) then
								index = 2
								sc = { "0x70003F48" }	
							elseif (nextLevel == 41) then
								index = 1
								sc = { }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 1
								sc = { }
							elseif (nextLevel == 44) then
								index = 1
								sc = { }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 2
								sc = { "0x70021D0E" }
							elseif (nextLevel == 48) then
								index = 2
								sc = { "0x70021D0E" }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 3
								sc = { "0x70021D18", "0x700153E5" }
							elseif (nextLevel == 52) then
								index = 3
								sc = { "0x70021D18", "0x700153E5" }
							elseif (nextLevel == 53) then
								index = 2
								sc = { "0x700153E2"  }
							elseif (nextLevel == 54) then
								index = 2
								sc = { "0x700153E2" }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 2
								sc = { "0x7000F9AB" }
							elseif (nextLevel == 58) then
								index = 2
								sc = { "0x7000F9AB" }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 2
								sc = { "0x70020DF8" }	
							elseif (nextLevel == 64) then
								index = 2
								sc = { "0x70020DF8" }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 2
								sc = { "0x7002984F" }
							elseif (nextLevel == 68) then
								index = 1
								sc = { }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 2
								sc = { "0x70029856" }
							elseif (nextLevel == 74) then
								index = 2
								sc = { "0x70029856" }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end
							
							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end
							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Minstrel) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Minstrel

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70003E7D" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70003E7D" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70003E7D" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x70003E7E" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70003E7E" }	
							elseif (nextLevel == 7) then
								index = 2
								sc = { "0x7000B697" }
							elseif (nextLevel == 8) then
								index = 2
								sc = { "0x7000B697" }
							elseif (nextLevel == 9) then
								index = 2
								sc = { "0x70003E82" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x70003E82" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "0x70003E82" }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x70003E82" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 3
								sc = { "0x70003E8B", "0x70003E85" }
							elseif (nextLevel == 15) then
								index = 3
								sc = { "0x70003E8B", "0x70003E85" }
							elseif (nextLevel == 16) then
								index = 3
								sc = { "0x70003E8B", "0x70003E85" }
							elseif (nextLevel == 17) then
								index = 1
								sc = { }
							elseif (nextLevel == 18) then
								index = 1
								sc = { }
							elseif (nextLevel == 19) then
								index = 2
								sc = { "0x70003E81" }
							elseif (nextLevel == 20) then
								index = 2
								sc = { "0x70003E81" }
							elseif (nextLevel == 21) then
								index = 1
								sc = { }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 1
								sc = { }
							elseif (nextLevel == 23) then
								index = 1
								sc = { }
							elseif (nextLevel == 24) then
								index = 1
								sc = { }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x700031B2" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x700031B2" }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 1
								sc = { }
							elseif (nextLevel == 29) then
								index = 1
								sc = { }
							elseif (nextLevel == 30) then
								index = 1
								sc = { }
							elseif (nextLevel == 31) then
								index = 1
								sc = { }
							elseif (nextLevel == 32) then
								index = 1
								sc = { }
							elseif (nextLevel == 33) then
								index = 3
								sc = { "0x7000B69B", "0x70003E8E" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 3
								sc = { "0x7000B69B", "0x70003E8E"  }
							elseif (nextLevel == 35) then
								index = 3
								sc = { "0x7000B69B", "0x70003E8E" }
							elseif (nextLevel == 36) then
								index = 3
								sc = { "0x70003E90", "0x7000BC01" }
							elseif (nextLevel == 37) then
								index = 3
								sc = { "0x70003E90", "0x7000BC01" }
							elseif (nextLevel == 38) then
								index = 3
								sc = { "0x70003E90", "0x7000BC01" }
							elseif (nextLevel == 39) then
								index = 1
								sc = { }
							elseif (nextLevel == 40) then
								index = 1
								sc = { }	
							elseif (nextLevel == 41) then
								index = 1
								sc = { }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 2
								sc = { "0x70001251" }
							elseif (nextLevel == 44) then
								index = 2
								sc = { "0x70001251" }	
							elseif (nextLevel == 45) then
								index = 2
								sc = { "0x70001251" }
							elseif (nextLevel == 46) then
								index = 2
								sc = { "0x7000B69E" }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 2
								sc = { "0x7000B69E" }
							elseif (nextLevel == 48) then
								index = 2
								sc = { "0x7000B69E" }
							elseif (nextLevel == 49) then
								index = 2
								sc = { "0x7000BC02" }
							elseif (nextLevel == 50) then
								index = 2
								sc = { "0x7000BC02" }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 2
								sc = { "0x7000F260" }
							elseif (nextLevel == 53) then
								index = 2
								sc = { "0x7000F260"  }
							elseif (nextLevel == 54) then
								index = 2
								sc = { "0x7000F260" }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 2
								sc = { "0x70020DF9" }	
							elseif (nextLevel == 64) then
								index = 2
								sc = { "0x70020DF9" }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 2
								sc = { "0x70029904" }
							elseif (nextLevel == 68) then
								index = 2
								sc = { "0x70029904" }
							elseif (nextLevel == 69) then
								index = 2
								sc = { "0x70029905" }
							elseif (nextLevel == 70) then
								index = 2
								sc = { "0x70029905" }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end	

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Champion) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Champion

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70003DFE" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70003E08" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70003E08" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x70003E08" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70003E08" }	
							elseif (nextLevel == 7) then
								index = 1
								sc = { }
							elseif (nextLevel == 8) then
								index = 1
								sc = { }
							elseif (nextLevel == 9) then
								index = 1
								sc = { }
							elseif (nextLevel == 10) then
								index = 1
								sc = { }
							elseif (nextLevel == 11) then
								index = 1
								sc = { }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x70003E04" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x70003E04" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x70003E04" }
							elseif (nextLevel == 15) then
								index = 2
								sc = { "0x70003E16" }
							elseif (nextLevel == 16) then
								index = 2
								sc = { "0x70003E16" }
							elseif (nextLevel == 17) then
								index = 1
								sc = { }
							elseif (nextLevel == 18) then
								index = 1
								sc = { }
							elseif (nextLevel == 19) then
								index = 4
								sc = { "0x7000F70E", "0x70003E0C", "0x7003B445" }
							elseif (nextLevel == 20) then
								index = 4
								sc = { "0x7000F70E", "0x70003E0C", "0x7003B445" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x70002D9D" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x70002D9D" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x70003E09" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x70003E09" }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x70003E0B" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x70003E0B" }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 1
								sc = { }
							elseif (nextLevel == 29) then
								index = 1
								sc = { }
							elseif (nextLevel == 30) then
								index = 1
								sc = { }
							elseif (nextLevel == 31) then
								index = 2
								sc = { "0x70003E0D" }
							elseif (nextLevel == 32) then
								index = 3
								sc = { "0x70003E0D", "0x70003E0E" }
							elseif (nextLevel == 33) then
								index = 2
								sc = { "0x70003E0E" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 3
								sc = { "0x70003E0E","0x70003E15"  }
							elseif (nextLevel == 35) then
								index = 2
								sc = { "0x70003E15" }
							elseif (nextLevel == 36) then
								index = 2
								sc = { "0x70003E15" }
							elseif (nextLevel == 37) then
								index = 1
								sc = { }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x70020DF3" }
							elseif (nextLevel == 39) then
								index = 2
								sc = { "0x70020DF3" }
							elseif (nextLevel == 40) then
								index = 2
								sc = { "0x70020DF3" }	
							elseif (nextLevel == 41) then
								index = 1
								sc = { }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 1
								sc = { }
							elseif (nextLevel == 44) then
								index = 2
								sc = { "0x70021D27" }	
							elseif (nextLevel == 45) then
								index = 2
								sc = { "0x70021D27" }
							elseif (nextLevel == 46) then
								index = 2
								sc = { "0x70021D27" }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 1
								sc = { }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = { }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end	

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Beorning) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Beorning

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x7004039B" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x7004039B" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x7004039B" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x7004039B" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x7004039B" }	
							elseif (nextLevel == 7) then
								index = 1
								sc = { }
							elseif (nextLevel == 8) then
								index = 1
								sc = { }
							elseif (nextLevel == 9) then
								index = 2
								sc = { "0x70040390" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x70040390" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "0x700403B6" }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x700403B6" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x7004039C" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x7004039C" }
							elseif (nextLevel == 15) then
								index = 2
								sc = { "0x7004039C" }
							elseif (nextLevel == 16) then
								index = 3
								sc = { "0x7004039C", "0x700403B7" }
							elseif (nextLevel == 17) then
								index = 2
								sc = { "0x700403B7" }
							elseif (nextLevel == 18) then
								index = 2
								sc = { "0x700403B7" }
							elseif (nextLevel == 19) then
								index = 4
								sc = { "0x7004039F", "0x7004039D", "0x700403BA" }
							elseif (nextLevel == 20) then
								index = 4
								sc = { "0x7004039F", "0x7004039D", "0x700403BA" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x7004039E" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x7004039E" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x7004039A" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x7004039A" }
							elseif (nextLevel == 25) then
								index = 1
								sc = { }	
							elseif (nextLevel == 26) then
								index = 1
								sc = { }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 2
								sc = { "0x700403B9" }
							elseif (nextLevel == 29) then
								index = 2
								sc = { "0x700403B9" }
							elseif (nextLevel == 30) then
								index = 2
								sc = { "0x700403B9" }
							elseif (nextLevel == 31) then
								index = 2
								sc = { "0x700403B8" }
							elseif (nextLevel == 32) then
								index = 2
								sc = { "0x700403B8" }
							elseif (nextLevel == 33) then
								index = 1
								sc = { }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 2
								sc = { "0x70042DB4"  }
							elseif (nextLevel == 35) then
								index = 2
								sc = { "0x70042DB4" }
							elseif (nextLevel == 36) then
								index = 2
								sc = { "0x70042DB4" }
							elseif (nextLevel == 37) then
								index = 1
								sc = { }
							elseif (nextLevel == 38) then
								index = 1
								sc = { }
							elseif (nextLevel == 39) then
								index = 1
								sc = { }
							elseif (nextLevel == 40) then
								index = 1
								sc = { }	
							elseif (nextLevel == 41) then
								index = 1
								sc = { }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 1 
								sc = { }
							elseif (nextLevel == 44) then
								index = 1
								sc = { }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 1
								sc = { }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = {  }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end		

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Burglar) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Burglar

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70003F0C" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70003F0C" }
							elseif (nextLevel == 4) then
								index = 2
								sc = { "0x70003F0C", "0x700031E1" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x700031E1" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70003F14" }	
							elseif (nextLevel == 7) then
								index = 3
								sc = { "0x70003F14", "0x700031D8" }
							elseif (nextLevel == 8) then
								index = 3
								sc = { "0x70003F14", "0x700031D8" }
							elseif (nextLevel == 9) then
								index = 2
								sc = { "0x70003F13" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x70003F13" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "0x70003F0D" }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x70003F0D" }
							elseif (nextLevel == 13) then
								index = 3
								sc = { "0x70003F0E", "0x70003F16" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 3
								sc = { "0x70003F0E", "0x70003F16" }
							elseif (nextLevel == 15) then
								index = 2
								sc = { "0x70003F17" }
							elseif (nextLevel == 16) then
								index = 2
								sc = { "0x70003F17" }
							elseif (nextLevel == 17) then
								index = 3
								sc = { "0x700031F5", "0x7002613D" }
							elseif (nextLevel == 18) then
								index = 3
								sc = { "0x700031F5", "0x7002613D" }
							elseif (nextLevel == 19) then
								index = 3
								sc = { "0x7003A68C", "0x70003F15" }
							elseif (nextLevel == 20) then
								index = 3
								sc = { "0x7003A68C", "0x70003F15" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x70003F11" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x70003F11" }
							elseif (nextLevel == 23) then
								index = 1
								sc = {  }
							elseif (nextLevel == 24) then
								index = 1
								sc = { }
							elseif (nextLevel == 25) then
								index = 3
								sc = { "0x7001F4A4", "0x7000D442" }	
							elseif (nextLevel == 26) then
								index = 3
								sc = { "0x7001F4A4", "0x7000D442" }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 2
								sc = { "0x7000320D" }
							elseif (nextLevel == 29) then
								index = 2
								sc = { "0x7000320D" }
							elseif (nextLevel == 30) then
								index = 2
								sc = { "0x7000320D" }
							elseif (nextLevel == 31) then
								index = 1
								sc = { }
							elseif (nextLevel == 32) then
								index = 1
								sc = { }
							elseif (nextLevel == 33) then
								index = 2
								sc = { "0x70003F0A" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 2
								sc = { "0x70003F0A"  }
							elseif (nextLevel == 35) then
								index = 2
								sc = { "0x70003F12" }
							elseif (nextLevel == 36) then
								index = 2
								sc = { "0x70003F12" }
							elseif (nextLevel == 37) then
								index = 1
								sc = { }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x7000D446" }
							elseif (nextLevel == 39) then
								index = 2
								sc = { "0x7000D446" }
							elseif (nextLevel == 40) then
								index = 2
								sc = { "0x7000D446" }	
							elseif (nextLevel == 41) then
								index = 2
								sc = { "0x7000D448" }
							elseif (nextLevel == 42) then
								index = 2
								sc = { "0x7000D448" }
							elseif (nextLevel == 43) then
								index = 1 
								sc = { }
							elseif (nextLevel == 44) then
								index = 1
								sc = { }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 2
								sc = { "0x7003038F" }
							elseif (nextLevel == 48) then
								index = 2
								sc = { "0x7003038F" }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 2
								sc = { "0x70015A02" }
							elseif (nextLevel == 53) then
								index = 2
								sc = { "0x70015A02"  }
							elseif (nextLevel == 54) then
								index = 2
								sc = { "0x70015A02" }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 2
								sc = { "0x70028385" }
							elseif (nextLevel == 65) then
								index = 2
								sc = { "0x70028385" }
							elseif (nextLevel == 66) then
								index = 2
								sc = { "0x70028385" }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = {  }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end		

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Captain) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Captain

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70003E4C" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70003E4C" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70003E4C" }
							elseif (nextLevel == 5) then
								index = 3
								sc = { "0x70002FAF", "0x70002F1A", "0x70002F7A" }
							elseif (nextLevel == 6) then
								index = 3
								sc = { "0x70002FAF", "0x70002F1A", "0x70002F7A"  }	
							elseif (nextLevel == 7) then
								index = 3
								sc = { "0x70003E4E", "0x70002F61" }
							elseif (nextLevel == 8) then
								index = 3
								sc = { "0x70003E4E", "0x70002F61" }
							elseif (nextLevel == 9) then
								index = 3
								sc = { "0x70003E50", "0x70020DF6" }
							elseif (nextLevel == 10) then
								index = 3
								sc = { "0x70003E50", "0x70020DF6" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "0x7000AA10" }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x7000AA10" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x70003E51" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x70003E51" }
							elseif (nextLevel == 15) then
								index = 3
								sc = { "0x70003E52", "0x70002F99" }
							elseif (nextLevel == 16) then
								index = 3
								sc = { "0x70003E52", "0x70002F99" }
							elseif (nextLevel == 17) then
								index = 1
								sc = { }
							elseif (nextLevel == 18) then
								index = 1
								sc = { }
							elseif (nextLevel == 19) then
								index = 5
								sc = { "0x7003A6A3", "0x70002F45", "0x7002F88D", "0x7000AA0E" }
							elseif (nextLevel == 20) then
								index = 5
								sc = { "0x7003A6A3", "0x70002F45", "0x7002F88D", "0x7000AA0E" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x7000A1D7" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x7000A1D7" }
							elseif (nextLevel == 23) then
								index = 1
								sc = {  }
							elseif (nextLevel == 24) then
								index = 1
								sc = { }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x7000FC78" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x7000FC78" }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 3
								sc = { "0x7000AD9A", "0x70028E4B" }
							elseif (nextLevel == 29) then
								index = 3
								sc = { "0x7000AD9A", "0x70028E4B" }
							elseif (nextLevel == 30) then
								index = 3
								sc = { "0x7000AD9A", "0x70028E4B" }
							elseif (nextLevel == 31) then
								index = 1
								sc = { }
							elseif (nextLevel == 32) then
								index = 1
								sc = { }
							elseif (nextLevel == 33) then
								index = 1
								sc = { }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 1
								sc = {  }
							elseif (nextLevel == 35) then
								index = 1
								sc = { }
							elseif (nextLevel == 36) then
								index = 1
								sc = { }
							elseif (nextLevel == 37) then
								index = 1
								sc = { }
							elseif (nextLevel == 38) then
								index = 3
								sc = { "0x70003E5A", "0x7000AA0D" }
							elseif (nextLevel == 39) then
								index = 3
								sc = { "0x70003E5A", "0x7000AA0D" }
							elseif (nextLevel == 40) then
								index = 3
								sc = { "0x70003E5A", "0x7000AA0D" }	
							elseif (nextLevel == 41) then
								index = 1
								sc = { }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 1 
								sc = { }
							elseif (nextLevel == 44) then
								index = 2
								sc = { "0x700385EE" }	
							elseif (nextLevel == 45) then
								index = 2
								sc = { "0x700385EE" }
							elseif (nextLevel == 46) then
								index = 2
								sc = { "0x700385EE" }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 2
								sc = { "0x70017D31" }
							elseif (nextLevel == 51) then
								index = 2
								sc = { "0x70017D31" }
							elseif (nextLevel == 52) then
								index = 2
								sc = { "0x70017D31" }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 2
								sc = { "0x7001F4C9" }
							elseif (nextLevel == 61) then
								index = 2
								sc = { "0x7001F4C9" }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 2
								sc = { "0x7001F4C9" }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 2
								sc = { "0x70028DB4" }
							elseif (nextLevel == 65) then
								index = 2
								sc = { "0x70028DB4" }
							elseif (nextLevel == 66) then
								index = 2
								sc = { "0x70028DB4" }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = {  }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 2
								sc = { "0x70028FA5" }
							elseif (nextLevel == 71) then
								index = 2
								sc = { "0x70028FA5" }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 2
								sc = { "0x70028FA5" }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end		

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Guardian) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Guardian

							if (nextLevel == 2) then	
								index = 2
								sc = { "0x70003EE0", "0x7000305D" }
							elseif (nextLevel == 3) then
								index = 3
								sc = { "0x70003EE0", "0x7000305D", "0x70003EDE" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70003EDE" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x70003EE4" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70003EE4"  }	
							elseif (nextLevel == 7) then
								index = 2
								sc = { "0x70003E14" }
							elseif (nextLevel == 8) then
								index = 2
								sc = { "0x70003E14" }
							elseif (nextLevel == 9) then
								index = 2
								sc = { "0x7000308D" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x7000308D" }
							elseif (nextLevel == 11) then
								index = 1
								sc = { }
							elseif (nextLevel == 12) then
								index = 1
								sc = { }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x7000DD14" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x7000DD14" }
							elseif (nextLevel == 15) then
								index = 2
								sc = { "0x70003097" }
							elseif (nextLevel == 16) then
								index = 2
								sc = { "0x70003097" }
							elseif (nextLevel == 17) then
								index = 2
								sc = { "0x70021663" }
							elseif (nextLevel == 18) then
								index = 2
								sc = { "0x70021663" }
							elseif (nextLevel == 19) then
								index = 3
								sc = { "0x70003058", "0x70003EE8" }
							elseif (nextLevel == 20) then
								index = 3
								sc = { "0x70003058", "0x70003EE8" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x70003EE1" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x70003EE1" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x7000D4B5" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x7000D4B5" }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x7000306F" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x7000306F" }
							elseif (nextLevel == 27) then
								index = 2
								sc = { "0x7000D4B3" }
							elseif (nextLevel == 28) then
								index = 2
								sc = { "0x7000D4B3" }
							elseif (nextLevel == 29) then
								index = 2
								sc = { "0x7000307D" }
							elseif (nextLevel == 30) then
								index = 2
								sc = { "0x7000307D" }
							elseif (nextLevel == 31) then
								index = 1
								sc = { }
							elseif (nextLevel == 32) then
								index = 1
								sc = { }
							elseif (nextLevel == 33) then
								index = 2
								sc = { "0x70003EE7" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 2
								sc = { "0x70003EE7"  }
							elseif (nextLevel == 35) then
								index = 2
								sc = { "0x70003EE9" }
							elseif (nextLevel == 36) then
								index = 2
								sc = { "0x70003EE9" }
							elseif (nextLevel == 37) then
								index = 2
								sc = { "0x7000D4B2" }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x7000D4B2" }
							elseif (nextLevel == 39) then
								index = 1
								sc = { }
							elseif (nextLevel == 40) then
								index = 1
								sc = { }	
							elseif (nextLevel == 41) then
								index = 1
								sc = { }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 1 
								sc = { }
							elseif (nextLevel == 44) then
								index = 1
								sc = { }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 1
								sc = { }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = {  }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end			

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end	
						
						if (player:GetClass() == Turbine.Gameplay.Class.LoreMaster) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.LoreMaster

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70003123" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70003123" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70003123" }
							elseif (nextLevel == 5) then
								index = 2
								sc = { "0x70003123", "0x70003EBB" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70003EE4", "0x70003EBB" }	
							elseif (nextLevel == 7) then
								index = 1
								sc = { }
							elseif (nextLevel == 8) then
								index = 1
								sc = { }
							elseif (nextLevel == 9) then
								index = 2
								sc = { "0x70003152" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x70003152" }
							elseif (nextLevel == 11) then
								index = 1
								sc = { }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x70003143" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x70003143" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 3
								sc = { "0x70003143", "0x70003EB5" }
							elseif (nextLevel == 15) then
								index = 4
								sc = { "0x70003EB5", "0x70003132", "0x70003116" }
							elseif (nextLevel == 16) then
								index = 3
								sc = { "0x70003132", "0x70003116" }
							elseif (nextLevel == 17) then
								index = 3
								sc = { "0x7000B60D", "0x70003EC2" }
							elseif (nextLevel == 18) then
								index = 3
								sc = { "0x7000B60D", "0x70003EC2",  }
							elseif (nextLevel == 19) then
								index = 6
								sc = { "0x7003A394", "0x7000F7FE", "0x7000F54D", "0x7000C588", "0x70003EBF" }
							elseif (nextLevel == 20) then
								index = 6
								sc = { "0x7003A394", "0x7000F7FE", "0x7000F54D", "0x7000C588", "0x70003EBF" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x7000316B" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x7000316B" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x7000F74D" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x7000F74D" }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x70003EBC" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x70003EBC" }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 3
								sc = { "0x7000B8D3", "0x7000314B" }
							elseif (nextLevel == 29) then
								index = 3
								sc = { "0x7000B8D3", "0x7000314B" }
							elseif (nextLevel == 30) then
								index = 3
								sc = { "0x7000B8D3", "0x7000314B" }
							elseif (nextLevel == 31) then
								index = 4
								sc = { "0x7000BFC2", "0x70003EBD", "0x7000B62B" }
							elseif (nextLevel == 32) then
								index = 4
								sc = { "0x7000BFC2", "0x70003EBD", "0x7000B62B" }
							elseif (nextLevel == 33) then
								index = 3
								sc = { "0x7000B62B", "0x70003EC1" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 2
								sc = { "0x70003EC1"  }
							elseif (nextLevel == 35) then
								index = 1
								sc = { }
							elseif (nextLevel == 36) then
								index = 1
								sc = { }
							elseif (nextLevel == 37) then
								index = 1
								sc = { }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x7002A706" }
							elseif (nextLevel == 39) then
								index = 2
								sc = { "0x7002A706" }
							elseif (nextLevel == 40) then
								index = 2
								sc = { "0x7002A706" }	
							elseif (nextLevel == 41) then
								index = 2
								sc = { "0x7000B627" }
							elseif (nextLevel == 42) then
								index = 2
								sc = { "0x7000B627" }
							elseif (nextLevel == 43) then
								index = 1 
								sc = { }
							elseif (nextLevel == 44) then
								index = 1
								sc = { }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 2
								sc = { "0x7000F530" }
							elseif (nextLevel == 55) then
								index = 2
								sc = { "0x7000F530" }
							elseif (nextLevel == 56) then
								index = 3
								sc = { "0x7000F530", "0x7000F801" }
							elseif (nextLevel == 57) then
								index = 2
								sc = { "0x7000F801" }
							elseif (nextLevel == 58) then
								index = 2
								sc = { "0x7000F801" }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 2
								sc = { "0x70028B80" }
							elseif (nextLevel == 65) then
								index = 2
								sc = { "0x70028B80" }
							elseif (nextLevel == 66) then
								index = 2
								sc = { "0x70028B80" }
							elseif (nextLevel == 67) then
								index = 2
								sc = { "0x70028B9A" }
							elseif (nextLevel == 68) then
								index = 2
								sc = { "0x70028B9A" }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 2
								sc = { "0x70028CA1" }
							elseif (nextLevel == 73) then
								index = 2
								sc = { "0x70028CA1" }
							elseif (nextLevel == 74) then
								index = 2
								sc = { "0x70028CA1" }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 2
								sc = { "0x7002E60F"  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 2
								sc = { "0x7002E60F"  }
							elseif (nextLevel == 78) then
								index = 2
								sc = { "0x7002E5D0"  }
							elseif (nextLevel == 79) then
								index = 2
								sc = { "0x7002E5D0"  }
							elseif (nextLevel == 80) then
								index = 2
								sc = { "0x7002E5D0" }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end	

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.RuneKeeper) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.RuneKeeper

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x7000EE02" }
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x7000EE02" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x7000EE02" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x7000EE02" }
							elseif (nextLevel == 6) then
								index = 2
								sc = { "0x7000EE02", "0x7000F488" }	
							elseif (nextLevel == 7) then
								index = 2
								sc = { "0x7000F488" }
							elseif (nextLevel == 8) then
								index = 2
								sc = { "0x7000F488" }
							elseif (nextLevel == 9) then
								index = 1
								sc = { }
							elseif (nextLevel == 10) then
								index = 1
								sc = { }
							elseif (nextLevel == 11) then
								index = 1
								sc = { }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x7000EEA7" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x7000EEA7" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x7000EEA7" }
							elseif (nextLevel == 15) then
								index = 1
								sc = { }
							elseif (nextLevel == 16) then
								index = 1
								sc = { }
							elseif (nextLevel == 17) then
								index = 3
								sc = { "0x7000EEA6", "0x7002D0CD" }
							elseif (nextLevel == 18) then
								index = 3
								sc = { "0x7000EEA6", "0x7002D0CD" }
							elseif (nextLevel == 19) then
								index = 4
								sc = { "0x7003CC4A", "0x70017EEB", "0x7000EDA1" }
							elseif (nextLevel == 20) then
								index = 4
								sc = { "0x7003CC4A", "0x70017EEB", "0x7000EDA1" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x700180F5" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x700180F5" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x7000EE01" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x7000EE01" }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x700180F2" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x700180F2" }
							elseif (nextLevel == 27) then
								index = 2
								sc = { "0x7003006F" }
							elseif (nextLevel == 28) then
								index = 2
								sc = { "0x7003006F" }
							elseif (nextLevel == 29) then
								index = 1
								sc = { }
							elseif (nextLevel == 30) then
								index = 1
								sc = { }
							elseif (nextLevel == 31) then
								index = 2
								sc = { "0x7000EDFF" }
							elseif (nextLevel == 32) then
								index = 2
								sc = { "0x7000EDFF" }
							elseif (nextLevel == 33) then
								index = 1
								sc = { }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 1
								sc = {  }
							elseif (nextLevel == 35) then
								index = 2
								sc = { "0x7000E037" }
							elseif (nextLevel == 36) then
								index = 2
								sc = { "0x7000E037" }
							elseif (nextLevel == 37) then
								index = 1
								sc = { }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x7000F25D" }
							elseif (nextLevel == 39) then
								index = 2
								sc = { "0x7000F25D" }
							elseif (nextLevel == 40) then
								index = 2
								sc = { "0x7000F25D" }	
							elseif (nextLevel == 41) then
								index = 1
								sc = {  }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 2 
								sc = { "0x7000EEAB" }
							elseif (nextLevel == 44) then
								index = 2
								sc = { "0x7000EEAB" }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 2
								sc = { "0x70018775" }
							elseif (nextLevel == 49) then
								index = 2
								sc = { "0x70018775" }
							elseif (nextLevel == 50) then
								index = 2
								sc = { "0x70018775" }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 1
								sc = { }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = { }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end	
							
							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Warden) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Warden

							if (nextLevel == 2) then	
								index = 1
								sc = { "0x70014833"}
							elseif (nextLevel == 3) then
								index = 1
								sc = { "0x70014833" }
							elseif (nextLevel == 4) then
								index = 1
								sc = { "0x70014833" }
							elseif (nextLevel == 5) then
								index = 1
								sc = { "0x70014833" }
							elseif (nextLevel == 6) then
								index = 1
								sc = { "0x70014833" }	
							elseif (nextLevel == 7) then
								index = 1
								sc = { }
							elseif (nextLevel == 8) then
								index = 5
								sc = { "0x7000EEC4", "0x700101D8", "0x70016A09", "0x70016A0A" }
							elseif (nextLevel == 9) then
								index = 5
								sc = { "0x7000EEC4", "0x700101D8", "0x70016A09", "0x70016A0A" }
							elseif (nextLevel == 10) then
								index = 5
								sc = { "0x7000EEC4", "0x700101D8", "0x70016A09", "0x70016A0A" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "PreciseBlow" }
							elseif (nextLevel == 12) then
								index = 4
								sc = { "PreciseBlow", "WarCry" }
							elseif (nextLevel == 13) then
								index = 4
								sc = { "0x70014860", "0x700105CC", "WarCry" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 3
								sc = { "0x70014860", "0x700105CC" }
							elseif (nextLevel == 15) then
								index = 5
								sc = { "0x7003A654", "Maddening Strike", "Conviction", "SuretyOfDeath" }
							elseif (nextLevel == 16) then
								index = 5
								sc = { "0x7003A654", "Maddening Strike", "Conviction", "SuretyOfDeath" }
							elseif (nextLevel == 17) then
								index = 2
								sc = { "PowerAttack" }
							elseif (nextLevel == 18) then
								index = 2
								sc = { }
							elseif (nextLevel == 19) then
								index = 5
								sc = { "0x70036551", "0x7000ED0E", "0x7003A395", "Reversal" }
							elseif (nextLevel == 20) then
								index = 5
								sc = { "0x70036551", "0x7000ED0E", "0x7003A395", "Reversal" }
							elseif (nextLevel == 21) then
								index = 10
								sc = { "0x7002850C", "0x7001509C", "0x7001509A", "0x7001509B", "0x7002850B", "0x7001509D", "0x70015098", "0x7002850A", "0x70015099" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 3
								sc = { "0x7002BEEC", "CombinationStrike" }
							elseif (nextLevel == 23) then
								index = 5
								sc = { "0x7002BEEC", "Safeguard", "Restoration", "FierceResolve" }
							elseif (nextLevel == 24) then
								index = 5
								sc = { "0x7002BEEC", "Safeguard", "Restoration", "FierceResolve" }
							elseif (nextLevel == 25) then
								index = 2
								sc = { "0x70014786" }	
							elseif (nextLevel == 26) then
								index = 2
								sc = { "0x70014786" }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 1
								sc = { }
							elseif (nextLevel == 29) then
								index = 2
								sc = { "PiercingStrike" }
							elseif (nextLevel == 30) then
								index = 2
								sc = { "PiercingStrike" }
							elseif (nextLevel == 31) then
								index = 3
								sc = { "0x70014798", "Onslaught" }
							elseif (nextLevel == 32) then
								index = 3
								sc = { "0x70014798", "Onslaught" }
							elseif (nextLevel == 33) then
								index = 4
								sc = { "DanceOfWar", "BrinkOfVictory", "Desolation" }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 4
								sc = { "DanceOfWar", "BrinkOfVictory", "Desolation"  }
							elseif (nextLevel == 35) then
								index = 1
								sc = { }
							elseif (nextLevel == 36) then
								index = 1
								sc = { }
							elseif (nextLevel == 37) then
								index = 3
								sc = { "0x70014831", "MightyBlow" }
							elseif (nextLevel == 38) then
								index = 3
								sc = { "0x70014831", "MightyBlow" }
							elseif (nextLevel == 39) then
								index = 4
								sc = { "0x70028906", "0x7003B619", "0x7001478E" }
							elseif (nextLevel == 40) then
								index = 4
								sc = { "0x70028906", "0x7003B619", "0x7001478E" }	
							elseif (nextLevel == 41) then
								index = 1
								sc = {  }
							elseif (nextLevel == 42) then
								index = 2
								sc = { "0x70014791" }
							elseif (nextLevel == 43) then
								index = 4 
								sc = { "0x70014791", "BoarsRush", "WallOfSteel" }
							elseif (nextLevel == 44) then
								index = 3
								sc = { "BoarsRush", "WallOfSteel" }	
							elseif (nextLevel == 45) then
								index = 2
								sc = { "SpearOfVirtue" }
							elseif (nextLevel == 46) then
								index = 2
								sc = { "SpearOfVirtue" }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 2
								sc = { "UnerringStrike" }
							elseif (nextLevel == 50) then
								index = 2
								sc = { "UnerringStrike" }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 2
								sc = { "AdroitManoeuvre" }
							elseif (nextLevel == 58) then
								index = 2
								sc = { "AdroitManoeuvre" }
							elseif (nextLevel == 59) then
								index = 3
								sc = { "TheDarkBeforeDawn", "ExultationOfBattle" }	
							elseif (nextLevel == 60) then
								index = 3
								sc = { "TheDarkBeforeDawn", "ExultationOfBattle" }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 1
								sc = { }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = { }
							elseif (nextLevel == 69) then
								index = 2
								sc = { "WardensTriumph" }
							elseif (nextLevel == 70) then
								index = 2
								sc = { "WardensTriumph" }
							elseif (nextLevel == 71) then
								index = 2
								sc = { "Resolution" }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 2
								sc = { "Resolution" }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 2
								sc = { "ResoundingChallenge"  }
							elseif (nextLevel == 80) then
								index = 2
								sc = { "ResoundingChallenge" }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						if (player:GetClass() == Turbine.Gameplay.Class.Brawler) then
						
							actLevel = _G.player:GetLevel()
							tempLevel = 1
							nextLevel = actLevel + tempLevel
							class = Turbine.Gameplay.Class.Brawler

							if (nextLevel == 2) then	
								index = 2
								sc = { "0x70058AC8", "0x7000EE02" }
							elseif (nextLevel == 3) then
								index = 2
								sc = { "0x70058AC8", "0x7000EE02" }
							elseif (nextLevel == 4) then
								index = 2
								sc = { "0x70058AC8", "0x7000EE02" }
							elseif (nextLevel == 5) then
								index = 2
								sc = { "0x7005B9D2", "0x7000EE02" }
							elseif (nextLevel == 6) then
								index = 2
								sc = { "0x7005B9D2", "0x7000F488" }	
							elseif (nextLevel == 7) then
								index = 2
								sc = { "0x700597F3" }
							elseif (nextLevel == 8) then
								index = 2
								sc = { "0x700597F3" }
							elseif (nextLevel == 9) then
								index = 2
								sc = { "0x70058C43" }
							elseif (nextLevel == 10) then
								index = 2
								sc = { "0x70058C43" }
							elseif (nextLevel == 11) then
								index = 2
								sc = { "0x70058C42" }
							elseif (nextLevel == 12) then
								index = 2
								sc = { "0x70058C42" }
							elseif (nextLevel == 13) then
								index = 2
								sc = { "0x70058C44" }
								MainFunction_Bree()
							elseif (nextLevel == 14) then
								index = 2
								sc = { "0x70058C44" }
							elseif (nextLevel == 15) then
								index = 2
								sc = { "0x70058C44" }
							elseif (nextLevel == 16) then
								index = 2
								sc = { "0x70058C4C" }
							elseif (nextLevel == 17) then
								index = 2
								sc = { "0x70058C4C" }
							elseif (nextLevel == 18) then
								index = 2
								sc = { "0x70058C4C" }
							elseif (nextLevel == 19) then
								index = 5
								sc = { "0x70058C4B", "0x70058C48", "0x70058C3B", "0x70058C3F" }
							elseif (nextLevel == 20) then
								index = 5
								sc = { "0x70058C4B", "0x70058C48", "0x70058C3B", "0x70058C3F" }
							elseif (nextLevel == 21) then
								index = 2
								sc = { "0x70058C4A" }	
								MainFunction_EinsameLande()
							elseif (nextLevel == 22) then
								index = 2
								sc = { "0x70058C4A" }
							elseif (nextLevel == 23) then
								index = 2
								sc = { "0x70058C50" }
							elseif (nextLevel == 24) then
								index = 2
								sc = { "0x70058C50" }
							elseif (nextLevel == 25) then
								index = 1
								sc = { }	
							elseif (nextLevel == 26) then
								index = 1
								sc = { }
							elseif (nextLevel == 27) then
								index = 1
								sc = { }
							elseif (nextLevel == 28) then
								index = 1
								sc = { }
							elseif (nextLevel == 29) then
								index = 2
								sc = { "0x700598BC" }
							elseif (nextLevel == 30) then
								index = 2
								sc = { "0x700598BC" }
							elseif (nextLevel == 31) then
								index = 2
								sc = { "0x70059D57" }
							elseif (nextLevel == 32) then
								index = 2
								sc = { "0x70059D57" }
							elseif (nextLevel == 33) then
								index = 1
								sc = { }
								MainFunction_Bruchtal()
							elseif (nextLevel == 34) then
								index = 1
								sc = {  }
							elseif (nextLevel == 35) then
								index = 1
								sc = { }
							elseif (nextLevel == 36) then
								index = 1
								sc = { }
							elseif (nextLevel == 37) then
								index = 2
								sc = { "0x70058C41" }
							elseif (nextLevel == 38) then
								index = 2
								sc = { "0x70058C41" }
							elseif (nextLevel == 39) then
								index = 1
								sc = { }
							elseif (nextLevel == 40) then
								index = 1
								sc = { }	
							elseif (nextLevel == 41) then
								index = 1
								sc = {  }
							elseif (nextLevel == 42) then
								index = 1
								sc = { }
							elseif (nextLevel == 43) then
								index = 1 
								sc = { }
							elseif (nextLevel == 44) then
								index = 1
								sc = { }	
							elseif (nextLevel == 45) then
								index = 1
								sc = { }
							elseif (nextLevel == 46) then
								index = 1
								sc = { }
								MainFunction_Moria()
							elseif (nextLevel == 47) then
								index = 1
								sc = { }
							elseif (nextLevel == 48) then
								index = 1
								sc = { }
							elseif (nextLevel == 49) then
								index = 1
								sc = { }
							elseif (nextLevel == 50) then
								index = 1
								sc = { }
							elseif (nextLevel == 51) then
								index = 1
								sc = { }
							elseif (nextLevel == 52) then
								index = 1
								sc = { }
							elseif (nextLevel == 53) then
								index = 1
								sc = {  }
							elseif (nextLevel == 54) then
								index = 1
								sc = { }
							elseif (nextLevel == 55) then
								index = 1
								sc = { }
							elseif (nextLevel == 56) then
								index = 1
								sc = { }
							elseif (nextLevel == 57) then
								index = 1
								sc = { }
							elseif (nextLevel == 58) then
								index = 1
								sc = { }
							elseif (nextLevel == 59) then
								index = 1
								sc = { }	
							elseif (nextLevel == 60) then
								index = 1
								sc = { }
							elseif (nextLevel == 61) then
								index = 1
								sc = { }
								MainFunction_Lothlorien()
							elseif (nextLevel == 62) then
								index = 1
								sc = { }
							elseif (nextLevel == 63) then
								index = 1
								sc = { }	
							elseif (nextLevel == 64) then
								index = 1
								sc = { }
							elseif (nextLevel == 65) then
								index = 1
								sc = { }
							elseif (nextLevel == 66) then
								index = 1
								sc = { }
							elseif (nextLevel == 67) then
								index = 1
								sc = { }
							elseif (nextLevel == 68) then
								index = 1
								sc = { }
							elseif (nextLevel == 69) then
								index = 1
								sc = { }
							elseif (nextLevel == 70) then
								index = 1
								sc = { }
							elseif (nextLevel == 71) then
								index = 1
								sc = { }
								MainFunction_Isengart()
							elseif (nextLevel == 72) then
								index = 1
								sc = { }
							elseif (nextLevel == 73) then
								index = 1
								sc = { }
							elseif (nextLevel == 74) then
								index = 1
								sc = { }
							elseif (nextLevel == 75) then
								index = 1
								sc = { }
							elseif (nextLevel == 76) then
								index = 1
								sc = {  }
								MainFunction_AmonHen()
							elseif (nextLevel == 77) then
								index = 1
								sc = {  }
							elseif (nextLevel == 78) then
								index = 1
								sc = {  }
							elseif (nextLevel == 79) then
								index = 1
								sc = {  }
							elseif (nextLevel == 80) then
								index = 1
								sc = { }
							elseif (nextLevel == 81) then
								index = 1
								sc = { }
							elseif (nextLevel == 82) then
								index = 1
								sc = { }	
							elseif (nextLevel == 83) then
								index = 1
								sc = { }
							elseif (nextLevel == 84) then
								index = 1
								sc = { }
							elseif (nextLevel == 85) then
								index = 1
								sc = { }
							elseif (nextLevel == 86) then
								index = 1
								sc = { }
								MainFunction_Edoras()
							elseif (nextLevel == 87) then
								index = 1
								sc = { }
							elseif (nextLevel == 88) then
								index = 1
								sc = { }
							elseif (nextLevel == 89) then
								index = 1
								sc = { }
							elseif (nextLevel == 90) then
								index = 1
								sc = { }
							elseif (nextLevel == 91) then
								index = 1
								sc = { }
							elseif (nextLevel == 92) then
								index = 1
								sc = { }
							elseif (nextLevel == 93) then
								index = 1
								sc = { }
							elseif (nextLevel == 94) then
								index = 1
								sc = { }
							elseif (nextLevel == 95) then
								index = 1
								sc = { }								
							elseif (nextLevel == 96) then
								index = 1
								sc = { }
								MainFunction_HelmsKlamm()
							elseif (nextLevel == 97) then
								index = 1
								sc = { }
							elseif (nextLevel == 98) then
								index = 1
								sc = { }
							elseif (nextLevel == 99) then
								index = 1
								sc = { }
							elseif (nextLevel == 100) then
								index = 1
								sc = { }
							elseif (nextLevel == 101) then
								index = 1
								sc = { }	
							elseif (nextLevel == 102) then
								index = 1
								sc = { }
							elseif (nextLevel == 103) then
								index = 1
								sc = { }
							elseif (nextLevel == 104) then
								index = 1
								sc = { }
							elseif (nextLevel == 105) then
								index = 1
								sc = { }
							elseif (nextLevel == 106) then
								index = 1
								sc = { }
								MainFunction_MinasTirith()
							elseif (nextLevel == 107) then
								index = 1
								sc = { }
								MainFunction_Mordor()
							elseif (nextLevel == 108) then
								index = 1
								sc = { }
							elseif (nextLevel == 109) then
								index = 1
								sc = { }
							elseif (nextLevel == 110) then
								index = 1
								sc = { }
							elseif (nextLevel == 111) then
								index = 1
								sc = { }
							elseif (nextLevel == 112) then
								index = 1
								sc = { }
							elseif (nextLevel == 113) then
								index = 1
								sc = { }
							elseif (nextLevel == 114) then
								index = 1
								sc = { }
							elseif (nextLevel == 115) then
								index = 1
								sc = { }
							elseif (nextLevel == 116) then
								index = 1
								sc = { }		
							elseif (nextLevel == 117) then
								index = 1
								sc = { }
							elseif (nextLevel == 118) then
								index = 1
								sc = { }
							elseif (nextLevel == 119) then
								index = 1
								sc = { }
							elseif (nextLevel == 120) then
								index = 1
								sc = { }	
							elseif (nextLevel == 121) then
								index = 1
								sc = { }
							elseif (nextLevel == 122) then
								index = 1
								sc = { }
							elseif (nextLevel == 123) then
								index = 1
								sc = { }
							elseif (nextLevel == 124) then
								index = 1
								sc = { }
							elseif (nextLevel == 125) then
								index = 1
								sc = { }
							elseif (nextLevel == 126) then
								index = 1
								sc = { }
							elseif (nextLevel == 127) then
								index = 1
								sc = { }
							elseif (nextLevel == 128) then
								index = 1
								sc = { }
							elseif (nextLevel == 129) then
								index = 1
								sc = { }
							elseif (nextLevel == 130) then
								index = 1
								sc = { }
							elseif (nextLevel == 131) then
								index = 1
								sc = { }
							elseif (nextLevel == 132) then
								index = 1
								sc = { }
							elseif (nextLevel == 133) then
								index = 1
								sc = { }
							elseif (nextLevel == 134) then
								index = 1
								sc = { }
							elseif (nextLevel == 135) then
								index = 1
								sc = { }	
							elseif (nextLevel == 136) then
								index = 1
								sc = { }
							elseif (nextLevel == 137) then
								index = 1
								sc = { }
							elseif (nextLevel == 138) then
								index = 1
								sc = { }
							elseif (nextLevel == 139) then
								index = 1
								sc = { }	
							elseif (nextLevel == 140) then
								index = 1
								sc = { }
							elseif (actLevel == 140) then
								index = 0
								sc = { }
								MainFunction_GraueAnfurten()
								mainWindow:SetVisible(false)
							end

							for _, level in ipairs({
								2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,23,25,27,29,31,33,35,37,39,41,43,45,47,49,50,51,53,55,57,58,59,60,61,62,63,64,65,66,68,70,72,74,75,76,78,80,82,84,85,86,88,90,92,94,95,96,97,98,99,100,101,102,103,104,105,106,108,110,112,114,115,116,117,118,119,120,121,123,125,127,129,130,131,133,135,137,139,140
							}) do
								table.insert(sc, string.format("TraitPoint%d", nextLevel))
								index = index + 1
								break
							end							
						end
						
						local controls = {}
						local windowskills = {}
						for i = 1, index , 1 do
							controls[#controls+1] = Turbine.UI.Control()
							windowskills[#windowskills+1] = Turbine.UI.Label()
							
							name = Thardariel.SkillData.shortcut[sc[i]]
							icon = Thardariel.SkillData.classShortcut[class][sc[i]].icon
							levelneed = Thardariel.SkillData.classShortcut[class][sc[i]].levelneed
							
							windowskills[i]=Turbine.UI.Label()
							windowskills[i]:SetParent(mainWindow.Message)
							windowskills[i]:SetSize(32,32)
							
							if ( i == 1 ) then
								mainWindow:SetSize(600,200);
								windowskills[i]:SetPosition(285,110)
							elseif ( i == 2 ) then
								mainWindow:SetSize(600,250);
								windowskills[i]:SetPosition(285,180)
							elseif ( i == 3 ) then
								mainWindow:SetSize(600,320);
								windowskills[i]:SetPosition(285,250)
							elseif ( i == 4 ) then
								mainWindow:SetSize(600,390);
								windowskills[i]:SetPosition(285,320)
							elseif ( i == 5 ) then
								mainWindow:SetSize(600,460);
								windowskills[i]:SetPosition(285,390)
							elseif ( i == 6 ) then
								mainWindow:SetSize(600,530);
								windowskills[i]:SetPosition(285,460)
							elseif ( i == 7 ) then
								mainWindow:SetSize(600,600);
								windowskills[i]:SetPosition(285,530)
							elseif ( i == 8 ) then
								mainWindow:SetSize(600,670);
								windowskills[i]:SetPosition(285,600)
							elseif ( i == 9 ) then
								mainWindow:SetSize(600,740);
								windowskills[i]:SetPosition(285,670)
							elseif ( i == 10 ) then
								mainWindow:SetSize(600,810);
								windowskills[i]:SetPosition(285,740)								
							end
							windowskills[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
							
							controls[i]=Turbine.UI.Control();
							controls[i]:SetSize(32,32)
							controls[i]:SetParent(windowskills[i]);
							controls[i]:SetBackground(icon);
							controls[i]:SetStretchMode(2);
									
							controls[i].Message1=Turbine.UI.Label()
							controls[i].Message1:SetParent(mainWindow)
							controls[i].Message1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
							if ( i == 1 ) then
								controls[i].Message1:SetPosition(0, 140)
							elseif ( i == 2 ) then
								controls[i].Message1:SetPosition(0, 210)
							elseif ( i == 3 ) then
								controls[i].Message1:SetPosition(0, 280)	
							elseif ( i == 4 ) then
								controls[i].Message1:SetPosition(0, 350)
							elseif ( i == 5 ) then
								controls[i].Message1:SetPosition(0, 420)
							elseif ( i == 6 ) then
								controls[i].Message1:SetPosition(0, 490)	
							elseif ( i == 7 ) then
								controls[i].Message1:SetPosition(0, 560)
							elseif ( i == 8 ) then
								controls[i].Message1:SetPosition(0, 630)
							elseif ( i == 9 ) then
								controls[i].Message1:SetPosition(0, 700)
							elseif ( i == 10 ) then
								controls[i].Message1:SetPosition(0, 770)								
							end
							controls[i].Message1:SetSize(600,30)
							controls[i].Message1:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
							
							local l = Turbine.Engine.GetLanguage()
							if l == Turbine.Language.English or l == Turbine.Language.EnglishGB then
								controls[i].Message1:SetText(string.format("%s from level %s", name, levelneed))
							elseif l == Turbine.Language.German then
								controls[i].Message1:SetText(string.format("%s ab Level %s", name, levelneed))
							elseif l == Turbine.Language.French then
								controls[i].Message1:SetText(string.format("%s à partir du niveau %s", name, levelneed))
							end
							
							
						end
				
		end
end

MainFunction_LevelUp()


